var finesse = finesse || {};
finesse.gadget = finesse.gadget || {};
finesse.container = finesse.container || {};
clientLogs = finesse.cslogger.ClientLogger || {};

finesse.modules = finesse.modules || {};
finesse.modules.Gadget = (function ($) {
    var user, dialogs, mediaList, mediaChat, chatMediaDialogs, chat;
	
	var nonVoiceActivitiesUIPanelName = 'panel_manageNonVoiceMedia';
	var nonVoiceActivitiesUISessionsPanel = 'sessionTabsId';
	var handleTimer = null;
	var handleNonVoiceIFrame = null;
	var newMessages = new Array();
	
    var toasterTitle = 'Notification';
	var toasterBody = 'New Chat Message';

    /** User load action */
    _handleUserLoad = function (userevent) {
		console.log("gadget.js > handleUserLoad > start");
		var mainFinesseWindow = window.top;
		var handleNonVoicePanel = mainFinesseWindow.document.getElementById(nonVoiceActivitiesUIPanelName);
		var handleNonVoiceIFramesList = handleNonVoicePanel.getElementsByTagName('iframe');
		if (handleNonVoiceIFramesList.length > 0) {
			handleNonVoiceIFrame = handleNonVoiceIFramesList[0].contentDocument || handleNonVoiceIFramesList[0].contentWindow.document;
			console.log("gadget.js > handleUserLoad > iframe id: " + handleNonVoiceIFramesList[0].id);
		}
		handleTimer = setInterval(_checkForNewMessages, 1000);		
		console.log("gadget.js > handleUserLoad > end");
    },
	/** Check if new chat message arrived to UI */
	_checkForNewMessages = function() {
		console.log("gadget.js > checkForNewMessages > start");
		try {
			var handleSessionsPanel = handleNonVoiceIFrame.getElementById(nonVoiceActivitiesUISessionsPanel);
			console.log("gadget.js > checkForNewMessages > sessions panel id: " + handleSessionsPanel.id);
			var eventCounters = handleSessionsPanel.getElementsByTagName('span');
			var eventRegex = /eventCounter-{0-9}+/g;
			console.log("gadget.js > checkForNewMessages > eventCounters length: " + eventCounters.length);
			for(var i=0; i< eventCounters.length; i++) {
				if ((eventCounters[i].id !== undefined) && (eventCounters[i].id.length > 0) && (eventCounters[i].id.indexOf('eventCounter') > -1)) {
					var sessionIndex = eventCounters[i].id.replace('eventCounter-','');
					var newStatus = eventCounters[i].innerHTML.trim();
					console.log("gadget.js > checkForNewMessages > session id: " + sessionIndex + ", status: '" + newStatus + "', old status: " + newMessages[sessionIndex]);
					if (newStatus == '') {
						newMessages[sessionIndex] = 0;
						newStatus = 0;
						console.log("gadget.js > checkForNewMessages > session id: " + sessionIndex + ", status after update: " + newStatus);
					}
					if (newMessages[sessionIndex] < newStatus) {
						newMessages[sessionIndex] = newStatus;
						console.log("gadget.js > checkForNewMessages > display popup");
						
						var notificationOptions = {
							body : toasterBody,
							tag : 'finesse-notification'
						}
						
						if (!("Notification" in window)) {}
						else if (Notification.permission === "granted") {
							notificationHandler = new Notification(toasterTitle, notificationOptions);
						}
						else if (Notification.permission !== 'denied') {
							Notification.requestPermission(function (permission) {
								if (permission === "granted") {
									notificationHandler = new Notification(toasterTitle, notificationOptions);
								}
							});
						}
					}
						
				}
			}
		} catch (error) {
			console.error("gadget.js > checkForNewMessages > error");
			console.error(error);
		}
		console.log("gadget.js > checkForNewMessages > end");
	}

    /** @scope finesse.modules.Gadget */
    return {

        /**
         * Performs all initialization for this gadget
         */
        init : function () {
            var cfg = finesse.gadget.Config;

            finesse.clientservices.ClientServices.init(cfg, false);
			
			clientLogs = finesse.cslogger.ClientLogger;
            clientLogs.init(gadgets.Hub, "Notification");
			
            user = new finesse.restservices.User({
                id: cfg.id, 
                onLoad : _handleUserLoad
            });
        }
    };
}(jQuery));